import liket.engine.Engine;
import liket.engine.work.Work;
import liket.util.TextUtil;


public class CommandShell extends Engine {

  public CommandShell() {
    init();
    library = new CommandLibrary(this);
  }

  // @Override
  public void action(int id, String[] args, Work sender) {
    switch (id) {
      //exec
    case 0:
      {
        try {
        String data = Main.loadSource(args);
        Main.print("execing: " + args[0] + "\n");
        exec(data);
        } catch(Exception ex) {
          if (ex.getMessage() == null) Main.print("failed to load " + args[0] + "\n");
          else Main.print(ex.getMessage() +"\n");
        }
        break;
      }
      //print
    case 1:
      {
        Main.print(args[0]);
        break;
      }
      //println
    case 2:
      {
        Main.print(args[0].concat("\n"));
        break;
      }
      //exit
    case 3:
      {
        shutDown();
        break;
      }
      //run
    case 4:
      {
        sender.execute(TextUtil.splitOutQuote(args[0], ';', '\"'));
        break;
      }
      //alert
    case 5:
      {
        Main.alert(args[0]);
        break;
      }
    }
  }

  public void error(String error, Work sender) {
    Main.print(error + "\n");
  }

}