package liket.engine.work;
/**
 *
 * @author Жалол
 */

import liket.engine.Library;
import liket.util.Arrays;
import liket.util.TextUtil;
import java.util.Vector;

public class Work {
  WorkListener workListener;
  Library library;
  boolean bRun = true;

  public Work() {}

  public void setLibrary(Library lib) {
    library = lib;
    workListener = library.workListener;
  }

  public void stop() {
    bRun = false;
  }

  public void execute(String[] lines) {
    int i = 0;
    while (bRun) {
      if (i >= lines.length) {
        break;
      }
      String line = lines[i].trim();
      if (line.equals("") || line.startsWith("; ")) {
        i++;
        continue;
      }

      String[] tokens = split(line);
      String command = tokens[0].toLowerCase();
      String[] arguments = new String[tokens.length - 1];

      for (int c = 1; c < tokens.length; c++) {
        arguments[c - 1] = tokens[c];
      }
      int id = library.getCommand(command);
      if (id == -1) {
        workListener.error("Unknown command: " + command + " at line " + i, this);
      } else {
        workListener.action(id, arguments, this);
      }
      i++;
    }
  }

  public String[] split(String line) {
    Vector v = new Vector();
    String str = "";
    line = line.trim();

    for (int i = 0; i < line.length(); i++) {
      char ch = line.charAt(i);

      if (ch == ' ') {
        if (!str.trim().equals("")) v.addElement(str.trim());
        str = "";
      }
      else if (ch == '\"') {
        str = TextUtil.quoteContent(line, '\"', i);
        int len = str.length();
        str = str.trim();
        v.addElement(TextUtil.toLiteral(str.substring(1, str.length() - 1)));
        i += len;
        str = "";
        continue;
      }
      else if (ch == '(') {
        str = TextUtil.braceContent(line, '(', ')', '\"', i);
        int len = str.length();
        str = str.trim();
        v.addElement(TextUtil.toLiteral(str.substring(1, str.length() - 1)));
        i += len;
        str = "";
        continue;
      }
      str += ch;
    }
    if (!str.trim().equals("")) v.addElement(str.trim());

    return Arrays.toStringArray(v);
  }
}