package liket.util;
/**
 *
 * @author Жалол
 */

import java.util.Vector;

public class TextUtil {
  public static final int BRACE_CORRECT = 0;
  public static final int BRACE_OPEN_EXPECTED = 1;
  public static final int BRACE_CLOSE_EXPECTED = 2;

  public static String toLiteral(String string) {
    String val = "";
    boolean isSlash = false;
    char ch;

    for (int i = 0; i < string.length(); i++) {
      ch = string.charAt(i);

      if (isSlash) {
        isSlash = false;
        if (ch == '\\') {
          val += ch;
        } else if (ch == 'n') {
          val += '\n';
        } else if (ch == 't') {
          val += '\t';
        } else if (ch == 'b') {
          val += '\b';
        } else if (ch == '\'') {
          val += '\'';
        } else if (ch == '\"') {
          val += '\"';
        } else {}
      } else {
        if (ch == '\\') {
          isSlash = true;
        } else {
          val += ch;
        }
      }
    }
    return val;
  }
  public static String quoteContent(String text, char quote, int i) {
    String content = "";
    Quote iQuote = new Quote(quote);

    for (; i < text.length(); i++) {
      char ch = text.charAt(i);

      if (!iQuote.inString(ch)) {
        content += ch;
        break;
      }
      content += ch;
    }

    return content;
  }

  public static String[] splitOutQuote(String text, char delim, char quote) {
    String content = "";
    Quote iQuote = new Quote(quote);
    Vector v = new Vector();

    for (int i = 0; i < text.length(); i++) {
      char ch = text.charAt(i);
      if (!iQuote.inString(ch)) {
        if (ch == delim) {
          if (!content.equals("")) v.addElement(content);
          content = "";
          continue;
        }
      }
      content += ch;
    }
    if (!content.equals("")) v.addElement(content);
    return Arrays.toStringArray(v);
  }

  public static String braceContent(String text, char openBrace, char closeBrace, char q, int i) {
    int braceLevel = 0;
    String content = new String();
    Quote quote = new Quote(q);

    for (; i < text.length(); i++) {
      char ch = text.charAt(i);
      if (!quote.inString(ch)) {
        if (ch == openBrace) {
          braceLevel++;
        }
        else if (ch == closeBrace) {
          braceLevel--;
          if (braceLevel == 0) {
            content += ch;
            break;
          }
        }
      }
      content += ch;
    }
    //        System.out.println(content);
    return content;
  }

  public static String[] split(String str, String delim) {
    String emp = new String();

    if (emp.equals(str) || delim == null || delim.length() == 0) return new String[] {
      str
    };
    Vector v = new Vector();
    int pos = 0;
    int newpos = str.indexOf(delim, 0);
    while (newpos != -1) {
      v.addElement(str.substring(pos, newpos));
      pos = newpos + delim.length();
      newpos = str.indexOf(delim, pos);
    }
    v.addElement(str.substring(pos));
    String[] s = new String[v.size()];
    v.copyInto(s);
    return s;
  }
}